$(() => {
const salesPivotGrid = $('#sales').dxPivotGrid({
allowFiltering: true,
allowSorting: true,
allowSortingBySummary: true,
height: 570,
showBorders: true,
headerFilter: {
allowSearch: true,
showRelevantValues: true,
width: 300,
height: 400,
},
fieldChooser: {
allowSearch: true,
},
fieldPanel: {
visible: true,
},
dataSource: {
fields: [
{ dataField: '[Product].[Category]', area: 'column' },
{ dataField: '[Product].[Subcategory]', area: 'column' },
{ dataField: '[Customer].[City]', area: 'row' },
{ dataField: '[Measures].[Internet Total Product Cost]', area: 'data', format: 'currency' },
{
dataField: '[Customer].[Country]',
area: 'filter',
filterValues: ['[Customer].[Country].&[United Kingdom]'],
},
{
dataField: '[Ship Date].[Calendar Year]',
area: 'filter',
filterValues: ['[Ship Date].[Calendar Year].&[2004]'],
},
],
store: {
type: 'xmla',
url: 'https://demos.devexpress.com/Services/OLAP/msmdpump.dll',
catalog: 'Adventure Works DW Standard Edition',
cube: 'Adventure Works',
},
},
}).dxPivotGrid('instance');
$('#allow-search').dxCheckBox({
text: 'Allow Search',
value: true,
onValueChanged(data) {
salesPivotGrid.option('headerFilter.allowSearch', data.value);
},
});
$('#show-relevant-values').dxCheckBox({
text: 'Show Relevant Values',
value: true,
onValueChanged(data) {
salesPivotGrid.option('headerFilter.showRelevantValues', data.value);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/22.1.3/js/dx.all.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="sales"></div>
<div class="options">
<div class="caption">Options</div>
<div class="options-container">
<div class="option">
<div id="allow-search"></div>
</div>
<div class="option">
<div id="show-relevant-values"></div>
</div>
</div>
</div>
</div>
</body>
</html>
#sales {
max-height: 570px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
width: 24%;
display: inline-block;
margin-top: 10px;
}
.options-container {
display: flex;
align-items: center;
}

<template>
<div>
<DxPivotGrid
id="sales"
:allow-filtering="true"
:allow-sorting="true"
:allow-sorting-by-summary="true"
:height="570"
:show-borders="true"
:data-source="dataSource"
>
<DxHeaderFilter
:allow-search="allowSearch"
:show-relevant-values="showRelevantValues"
:width="300"
:height="400"
/>
<DxFieldChooser
:allow-search="true"
/>
<DxFieldPanel
:visible="true"
/>
</DxPivotGrid>
<div class="options">
<div class="caption">Options</div>
<div class="options-container">
<div class="option">
<DxCheckBox
v-model:value="allowSearch"
text="Allow Search"
/>
</div>
<div class="option">
<DxCheckBox
v-model:value="showRelevantValues"
text="Show Relevant Values"
/>
</div>
</div>
</div>
</div>
</template>
<script>
import {
DxPivotGrid, DxHeaderFilter, DxFieldChooser, DxFieldPanel,
} from 'devextreme-vue/pivot-grid';
import { DxCheckBox } from 'devextreme-vue/check-box';
import PivotGridDataSource from 'devextreme/ui/pivot_grid/data_source';
import XmlaStore from 'devextreme/ui/pivot_grid/xmla_store';
export default {
components: {
DxPivotGrid,
DxHeaderFilter,
DxFieldChooser,
DxFieldPanel,
DxCheckBox,
},
data() {
return {
allowSearch: true,
showRelevantValues: true,
dataSource: new PivotGridDataSource({
fields: [
{ dataField: '[Product].[Category]', area: 'column' },
{ dataField: '[Product].[Subcategory]', area: 'column' },
{ dataField: '[Customer].[City]', area: 'row' },
{ dataField: '[Measures].[Internet Total Product Cost]', area: 'data', format: 'currency' },
{
dataField: '[Customer].[Country]',
area: 'filter',
filterValues: ['[Customer].[Country].&[United Kingdom]'],
},
{
dataField: '[Ship Date].[Calendar Year]',
area: 'filter',
filterValues: ['[Ship Date].[Calendar Year].&[2004]'],
},
],
store: new XmlaStore({
type: 'xmla',
url: 'https://demos.devexpress.com/Services/OLAP/msmdpump.dll',
catalog: 'Adventure Works DW Standard Edition',
cube: 'Adventure Works',
}),
}),
};
},
};
</script>
<style scoped>
#sales {
max-height: 570px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
width: 24%;
display: inline-block;
margin-top: 10px;
}
.options-container {
display: flex;
align-items: center;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.4/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.1.4',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.63/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.32/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

<dx-pivot-grid id="sales"
[allowSortingBySummary]="true"
[allowSorting]="true"
[allowFiltering]="true"
[showBorders]="true"
[height]="570"
[dataSource]="pivotGridDataSource">
<dxo-header-filter
[allowSearch]="allowSearch"
[showRelevantValues]="showRelevantValues"
[width]="300"
[height]="400"
></dxo-header-filter>
<dxo-field-chooser
[allowSearch]="true"
></dxo-field-chooser>
<dxo-field-panel
[visible]="true">
</dxo-field-panel>
</dx-pivot-grid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<dx-check-box
text="Allow Search"
[(value)]="allowSearch"></dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Show Relevant Values"
[(value)]="showRelevantValues"></dx-check-box>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxPivotGridModule, DxCheckBoxModule } from 'devextreme-angular';
import PivotGridDataSource from 'devextreme/ui/pivot_grid/data_source';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
preserveWhitespaces: true
})
export class AppComponent {
pivotGridDataSource: any;
allowSearch: boolean = true;
showRelevantValues: boolean = true;
constructor() {
this.pivotGridDataSource = new PivotGridDataSource({
fields: [
{ dataField: "[Product].[Category]", area: "column" },
{ dataField: "[Product].[Subcategory]", area: "column" },
{ dataField: "[Customer].[City]", area: "row" },
{ dataField: "[Measures].[Internet Total Product Cost]", area: "data", format: "currency" },
{
dataField: "[Customer].[Country]",
area: "filter",
filterValues: ["[Customer].[Country].&[United Kingdom]"]
},
{
dataField: "[Ship Date].[Calendar Year]",
area: "filter",
filterValues: ["[Ship Date].[Calendar Year].&[2004]"]
}
],
store: {
type: "xmla",
url: "https://demos.devexpress.com/Services/OLAP/msmdpump.dll",
catalog: "Adventure Works DW Standard Edition",
cube: "Adventure Works"
}
});
}
}
@NgModule({
imports: [
BrowserModule,
DxPivotGridModule,
DxCheckBoxModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #sales {
max-height: 570px;
}
::ng-deep .options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
::ng-deep .caption {
font-size: 18px;
font-weight: 500;
}
::ng-deep .option {
width: 24%;
display: inline-block;
margin-top: 10px;
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.0.3/tslib.js',
'rxjs': 'npm:rxjs@6.3.3',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8',
'devextreme-angular': 'npm:devextreme-angular@20.2.4',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import {
PivotGrid, HeaderFilter, FieldChooser, FieldPanel,
} from 'devextreme-react/pivot-grid';
import { CheckBox } from 'devextreme-react/check-box';
import PivotGridDataSource from 'devextreme/ui/pivot_grid/data_source';
import XmlaStore from 'devextreme/ui/pivot_grid/xmla_store';
const dataSource = new PivotGridDataSource({
fields: [
{ dataField: '[Product].[Category]', area: 'column' },
{ dataField: '[Product].[Subcategory]', area: 'column' },
{ dataField: '[Customer].[City]', area: 'row' },
{ dataField: '[Measures].[Internet Total Product Cost]', area: 'data', format: 'currency' },
{
dataField: '[Customer].[Country]',
area: 'filter',
filterValues: ['[Customer].[Country].&[United Kingdom]'],
},
{
dataField: '[Ship Date].[Calendar Year]',
area: 'filter',
filterValues: ['[Ship Date].[Calendar Year].&[2004]'],
},
],
store: new XmlaStore({
type: 'xmla',
url: 'https://demos.devexpress.com/Services/OLAP/msmdpump.dll',
catalog: 'Adventure Works DW Standard Edition',
cube: 'Adventure Works',
}),
});
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
allowSearch: true,
showRelevantValues: true,
};
this.onAllowSearchChanged = this.onAllowSearchChanged.bind(this);
this.onShowRelevantValuesChanged = this.onShowRelevantValuesChanged.bind(this);
}
render() {
const { allowSearch, showRelevantValues } = this.state;
return (
<div>
<PivotGrid
id="sales"
allowFiltering={true}
allowSorting={true}
allowSortingBySummary={true}
height={570}
showBorders={true}
dataSource={dataSource}
>
<HeaderFilter
allowSearch={allowSearch}
showRelevantValues={showRelevantValues}
width={300}
height={400}
/>
<FieldChooser allowSearch={true} />
<FieldPanel visible={true} />
</PivotGrid>
<div className="options">
<div className="caption">Options</div>
<div className="options-container">
<div className="option">
<CheckBox
value={allowSearch}
text="Allow Search"
onValueChanged={this.onAllowSearchChanged}
/>
</div>
<div className="option">
<CheckBox
value={showRelevantValues}
text="Show Relevant Values"
onValueChanged={this.onShowRelevantValuesChanged}
/>
</div>
</div>
</div>
</div>
);
}
onAllowSearchChanged(data) {
this.setState({
allowSearch: data.value,
});
}
onShowRelevantValuesChanged(data) {
this.setState({
showRelevantValues: data.value,
});
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#sales {
max-height: 570px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
width: 24%;
display: inline-block;
margin-top: 10px;
}
.options-container {
display: flex;
align-items: center;
}
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.18/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);